#!/usr/bin/env python

"""Simple tool for proofing pics

We display each pic and allow for
rotation,
annotation,
deletion

$Id: pictool.py,v 1.11 2006/12/14 00:45:47 sjg Exp $
"""

from Pic import *
from Tkinter import *
from tkMessageBox import *
import os, sys

class picTool(PicTool):
    pub_fp = None
    gal_fp = None
    show_deleted = False
    junk_dir = None

    def setupPics(self):
        PicTool.setupPics(self)
        if self.pics:
            try:
                x = self.rotated.keys().sort()[0]
                x, e = os.path.splitext(x)
                last = int(x)
                for i in range(len(self.pics)):
                    b, e = os.path.splitext(self.pics[i])
                    if int(b) > last:
                        self.index = i
                        break
            except: pass
                
    def askSave(self):
        if self.changed != 0:
            #a = askyesno('Ask save', 'Save %s?' % self.picName)
            #if a:
	   self.doSave()

    def doShowDeleted(self):
        self.show_deleted = (self.show_deleted == False)

    def onKeyPress(self, event):
        if event.char == '?':
            self.doHelp()
        elif event.char == 'P':
            self.doPublic()
        elif event.char == 'G':
            self.doGallery()
        elif event.char == 'u':
            self.doUnDelete()
        elif event.char == '^':
            self.doShowDeleted()
        else:
            PicTool.onKeyPress(self, event)

    def doHelp(self):
        print >> sys.stderr, """Use:
? - this help
a - annotate
n - next image
r - rotate right (clockwise)
l - rotate left
d - delete
u - undelete
^ - toggle show deleted
+/= - zoom in
- - zoom out
e - exif
q - quit
s - save
P - push to [semi-]public collection
G - push to public gallery
"""
    def doGallery(self):
        if not self.gal_fp:
            file = getConfig(self.conf, 'galFile', '/tmp/gallist')
            self.gal_fp = open(file, 'a')
        print >> self.gal_fp, self.picName
    
    def doPublic(self):
        if not self.pub_fp:
            file = getConfig(self.conf, 'pubFile', '/tmp/publist')
            self.pub_fp = open(file, 'a')
        print >> self.pub_fp, self.picName
        
    def doPrevious(self):
        self.askSave()
        PicTool.doPrevious(self, self.show_deleted)

    def doNext(self):
        self.askSave()
        PicTool.doNext(self, self.show_deleted)

    def doQuit(self):
        self.askSave()
        self.doDeletes()
        PicTool.doQuit(self)

    def doUnDelete(self):
        i = self.index
        while ((self.increment < 0 and i < len(self.pics)) or
               (self.increment > 0 and i >= 0)):
            if not self.deleted.has_key(i):
                i -= self.increment
            else:
                self.selectPic(i)
                break
        if i >= 0 and i < len(self.pics) and self.deleted.has_key(i):
            a = askokcancel('Undelete', 'Undelete %s* ?' % self.pics[i])
            if not a:
                return
            del self.deleted[i]

    def doDelete(self):
        a = askokcancel('Verify delete', 'Delete %s* ?' % self.picName)
        if not a:
            return
        self.deleted[self.index] = 1
        self.nextPic(self.show_deleted)

    def doDeletes(self):
        if len(self.deleted) == 0:
            return
        a = askyesno('Verify deletes', 'Process Deletes?')
        if not a:
            return
        if not self.junk_dir:
            # try to avoid cross-dev moves, create a .junk dir
            # in the same parent dir.
            if self.picFile.find("/") >= 0:
                self.junk_dir = "%s/.junk" % os.path.dirname(self.picFile)
            else:
                self.junk_dir = "./.junk"
            if os.path.exists(self.junk_dir) and not os.path.isdir(self.junk_dir):
                print >> sys.stderr, "WARNING: Removing suspicious %s" % self.junk_dir
                os.remove(self.junk_dir)
            if not os.path.exists(self.junk_dir):
                os.mkdir(self.junk_dir)
            print >> sys.stderr, "Moving deleted files to %s" % self.junk_dir
        if os.path.exists(self.junk_dir) and os.path.isdir(self.junk_dir):
            for i in range(len(self.pics)):
                if self.deleted.has_key(i):
                    (base, ext) = os.path.splitext(self.pics[i])
                    if base.endswith("-w") or base.endswith("-t"):
                        base = base[0:-2]
                    cmd = "mv %s* %s" % (base, self.junk_dir)
                    print >> sys.stderr, cmd
                    os.system(cmd)

    def maybeQuit(self):
        a = askokcancel('Verify quit', 'Quit?')
        if not a:
            return
        self.doQuit()

if __name__ == '__main__':
    main(picTool)
